import React, { useState } from "react";
import { MdDownload, MdExpandLess, MdExpandMore ,MdRefresh} from "react-icons/md";
export function FileView({ generateFile, grammar,getFile }) {
  const [xml, setXml] = useState(false);
  const [more, setMore] = useState(false);

  return (
    <>
      <p>
        <button onClick={() => setXml(!xml)}>{xml ? "JSGF" : "XML"}</button>{" "}
        <button onClick={() => generateFile(xml, grammar.id)}>
          GENERATE {xml ? "XML" : "JSGF"}{" "}
        </button>{" "}
        <a
          href={
            "http://localhost:8080/api/grammars/" +
            grammar.id +
            "/file/new/" +
            (xml ? "xml" : "jsgf") +
            "/download"
          }
        >
          <MdDownload />
        </a>{" "}
      </p>
      {(xml ? grammar.xmlGen : grammar.jsgfGen) && (
        <p>
          <textarea
            className="transparent"
            readOnly={true}
            rows="4"
            cols="50"
            value={xml ? grammar.xmlGen : grammar.jsgfGen}
          />
        </p>
      )}
      {more ? (
        <MdExpandLess onClick={() => setMore(!more)} />
      ) : (
        <MdExpandMore onClick={() => setMore(!more)} />
      )}

      {more && grammar.files.map((file) => (
        <div key={file.id}>

          {file.generated ? "GEN": "NOGEN"}{" "}
          {file.xml ? "XML": "JSGF"}{" "}
          <MdRefresh onClick={()=>getFile(file.id,grammar.id)} />
          <a
          href={
            "http://localhost:8080/api/grammars/file/" +
            +file.id+
            "/download"
          }
        >
          <MdDownload />
        </a>{" "}
        {file.content&&<textarea
            className="transparent"
            readOnly={true}
            rows="4"
            cols="50"
            value={file.content}
          />}
        </div>
      ))}
    </>
  );
}
